## org.eclipse.jst.jsf.common.metadata.query
Class AbstractTraitVisitor

    java.lang.Object
      org.eclipse.jst.jsf.common.metadata.query.AbstractMetaDataVisitor
          org.eclipse.jst.jsf.common.metadata.query.AbstractTraitVisitor

All Implemented Interfaces:
  IMetaDataVisitor, ITraitVisitor

Direct Known Subclasses:
  AbstractTraitQueryVisitor

    public abstract class AbstractTraitVisitor

extends AbstractMetaDataVisitor
implements ITraitVisitor

Abstract Trait visitor

Provisional API - subject to change

Constructor Summary
`AbstractTraitVisitor()`

Method Summary
`abstract void` `visit(Trait trait)` Visit the Trait.
`void` `visitCompleted(Trait trait)` Signal that the the trait has been completely visited

Methods inherited from class org.eclipse.jst.jsf.common.metadata.query.AbstractMetaDataVisitor
`stopVisiting`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.eclipse.jst.jsf.common.metadata.query.IMetaDataVisitor
`stopVisiting`

Constructor Detail

### AbstractTraitVisitor

    public AbstractTraitVisitor()

Method Detail

### visit

    public abstract void visit(Trait trait)

  Description copied from interface: `ITraitVisitor`
  Visit the Trait. Implementer cannot assume ordering of trait visiting.

  Specified by:
    `visit` in interface `ITraitVisitor`
  Parameters:
    `trait` - - must not be null

### visitCompleted

    public void visitCompleted(Trait trait)

  Description copied from interface: `ITraitVisitor`
  Signal that the the trait has been completely visited

  Specified by:
    `visitCompleted` in interface `ITraitVisitor`